using System;

namespace GameKnight.Core
{

	public interface IVideoMemory
	{

		IAttributeTable[] GetAttributeTables();

        IMap[] GetMaps();

        INameTable[] GetNameTables();
        
		IPalette[] GetPalettes();

		IPalette GetPalette( int Index );

		IPatternTable GetPatternTable( int Index );

        IPatternTable[] GetPatternTables();
        
		ISprite[] GetSprites();
		
		byte ReadU8( int Address );
	
		ushort ReadU16( int Address );
	
		void WriteU8( int Address, byte Value );
		
		void WriteU16( int Address, ushort Value );
          
	}
	
}
