﻿using System;
using GameKnight.Core;

namespace GameKnight
{
	
	namespace GameBoy
	{
	
		public partial class Processor : IProcessor
		{
			
			protected partial class Opcode
			{
			
				public static int LD_A_mFFC( Processor Processor, Opcode Opcode )
				{
					Processor.A = Processor.Memory.ReadU8( 0xFF00 | Processor.C );
					return 0;
				}
				
				public static int LD_A_mFFN8( Processor Processor, Opcode Opcode )
				{
					Processor.A = Processor.Memory.ReadU8( 0xFF00 | Processor.Memory.ReadU8( Processor.PC++ ) );
					return 0;
				}
				
				public static int LD_A_mN16( Processor Processor, Opcode Opcode )
				{
					Processor.A = Processor.Memory.ReadU8( Processor.Memory.ReadU16( Processor.PC ) );
					Processor.PC += 2;
					return 0;
				}
				
				public static int LD_A_mR16( Processor Processor, Opcode Opcode )
				{
					Processor.A = Processor.Memory.ReadU8( Processor.RegisterPairArray[((Opcode.Value>>4)&0x01)].Value );
					return 0;
				}
				
				public static int LD_mFFC_A( Processor Processor, Opcode Opcode )
				{
					Processor.Memory.WriteU8( ( 0xFF00 | Processor.C ), Processor.A );
					return 0;
				}
				
				public static int LD_mFFN8_A( Processor Processor, Opcode Opcode )
				{
					Processor.Memory.WriteU8( ( 0xFF00 | Processor.Memory.ReadU8( Processor.PC++ ) ), Processor.A );
					return 0;
				}
				
				public static int LD_mHL_N8( Processor Processor, Opcode Opcode )
				{
					Processor.Memory.WriteU8( Processor.HL, Processor.Memory.ReadU8( Processor.PC++ ) );
					return 0;
				}
				
				public static int LD_mHL_R8( Processor Processor, Opcode Opcode )
				{
					Processor.Memory.WriteU8( Processor.HL, Processor.GetRegisterValue( Opcode.Value & 0x07 ) );
					return 0;
				}
				
				public static int LD_mN16_A( Processor Processor, Opcode Opcode )
				{
					Processor.Memory.WriteU8( Processor.Memory.ReadU16( Processor.PC ), Processor.A );
					Processor.PC += 2;
					return 0;
				}
				
				public static int LD_mR16_A( Processor Processor, Opcode Opcode )
				{
					Processor.Memory.WriteU8( Processor.RegisterPairArray[((Opcode.Value>>4)&0x01)].Value, Processor.A );
					return 0;
				}
				
				public static int LD_R8_mHL( Processor Processor, Opcode Opcode )
				{
					Processor.SetRegisterValue( ( ( Opcode.Value >> 3 ) & 0x07 ), Processor.Memory.ReadU8( Processor.HL ) );
					return 0;
				}
				
				public static int LD_R8_N8( Processor Processor, Opcode Opcode )
				{
					Processor.SetRegisterValue( ( ( Opcode.Value >> 3 ) & 0x07 ), Processor.Memory.ReadU8( Processor.PC++ ) );
					return 0;
				}
				
				public static int LD_R8_R8( Processor Processor, Opcode Opcode )
				{
					Processor.SetRegisterValue( ( ( Opcode.Value >> 3 ) & 0x07 ), Processor.GetRegisterValue( Opcode.Value & 0x07 ) );
					return 0;
				}
				
				public static int LDD_A_mHL( Processor Processor, Opcode Opcode )
				{
					Processor.A = Processor.Memory.ReadU8( Processor.HL-- );
					return 0;
				}
				
				public static int LDD_mHL_A( Processor Processor, Opcode Opcode )
				{
					Processor.Memory.WriteU8( Processor.HL--, Processor.A );
					return 0;
				}
				
				public static int LDI_A_mHL( Processor Processor, Opcode Opcode )
				{
					Processor.A = Processor.Memory.ReadU8( Processor.HL++ );
					return 0;
				}
				
				public static int LDI_mHL_A( Processor Processor, Opcode Opcode )
				{
					Processor.Memory.WriteU8( Processor.HL++, Processor.A );
					return 0;
				}
				
			}
			
		}
		
	}
	
}
	
