﻿using System;
using GameKnight.Core;

namespace GameKnight
{
	
	namespace GameBoy
	{
	
		public partial class Processor : IProcessor
		{
			
			protected partial class Opcode
			{

				public static readonly Opcode[] Table = new Opcode[]
				{
					new Opcode( 0x00, NOP, 4, "NOP" ),
					new Opcode( 0x01, LD_R16_N16, 10, "LD %R, %N" ),
					new Opcode( 0x02, LD_mR16_A, 7, "LD (%R), A" ),
					new Opcode( 0x03, INC16, 6, "INC %R" ),
					new Opcode( 0x04, INC8, 4, "INC %r3" ),
					new Opcode( 0x05, DEC8, 4, "DEC %r3" ),
					new Opcode( 0x06, LD_R8_N8, 7, "LD %r3, %n" ),
					new Opcode( 0x07, RLCA, 4, "RLCA" ),				
					new Opcode( 0x08, LD_mN16_SP, 15, "LD (%N), SP" ),
					new Opcode( 0x09, ADD_HL_R16, 11, "ADD HL, %R" ),
					new Opcode( 0x0A, LD_A_mR16, 7, "LD A, (%R)" ),
					new Opcode( 0x0B, DEC16, 6, "DEC %R" ),
					new Opcode( 0x0C, INC8, 4, "INC %r3" ),
					new Opcode( 0x0D, DEC8, 4, "DEC %r3" ),
					new Opcode( 0x0E, LD_R8_N8, 7, "LD %r3, %n" ),
					new Opcode( 0x0F, RRCA, 4, "RRCA" ),
					new Opcode( 0x10, STOP, 4, "STOP" ),
					new Opcode( 0x11, LD_R16_N16, 10, "LD %R, %N" ),
					new Opcode( 0x12, LD_mR16_A, 7, "LD (%R), A" ),
					new Opcode( 0x13, INC16, 6, "INC %R" ),
					new Opcode( 0x14, INC8, 4, "INC %r3" ),
					new Opcode( 0x15, DEC8, 4, "DEC %r3" ),
					new Opcode( 0x16, LD_R8_N8, 7, "LD %r3, %n" ),
					new Opcode( 0x17, RLA, 4, "RLA" ),
					new Opcode( 0x18, JR, 12, "JR %e" ),
					new Opcode( 0x19, ADD_HL_R16, 11, "ADD HL, %R" ),
					new Opcode( 0x1A, LD_A_mR16, 7, "LD A, (%R)" ),
					new Opcode( 0x1B, DEC16, 6, "DEC %R" ),
					new Opcode( 0x1C, INC8, 4, "INC %r3" ),
					new Opcode( 0x1D, DEC8, 4, "DEC %r3" ),
					new Opcode( 0x1E, LD_R8_N8, 7, "LD %r3, %n" ),
					new Opcode( 0x1F, RRA, 4, "RRA" ),
					new Opcode( 0x20, JR_CC, 7, "JR %C, %e" ),
					new Opcode( 0x21, LD_R16_N16, 10, "LD %R, %N" ),
					new Opcode( 0x22, LDI_mHL_A, 7, "LDI (HL), A" ),
					new Opcode( 0x23, INC16, 6, "INC %R" ),
					new Opcode( 0x24, INC8, 4, "INC %r3" ),
					new Opcode( 0x25, DEC8, 4, "DEC %r3" ),
					new Opcode( 0x26, LD_R8_N8, 7, "LD %r3, %n" ),
					new Opcode( 0x27, DAA, 4, "DAA" ),			
					new Opcode( 0x28, JR_CC, 7, "JR %C, %e" ),
					new Opcode( 0x29, ADD_HL_R16, 11, "ADD HL, %R" ),
					new Opcode( 0x2A, LDI_A_mHL, 7, "LDI A, (HL)" ),
					new Opcode( 0x2B, DEC16, 6, "DEC %R" ),
					new Opcode( 0x2C, INC8, 4, "INC %r3" ),
					new Opcode( 0x2D, DEC8, 4, "DEC %r3" ),
					new Opcode( 0x2E, LD_R8_N8, 7, "LD %r3, %n" ),
					new Opcode( 0x2F, CPL, 4, "CPL" ),				
					new Opcode( 0x30, JR_CC, 7, "JR %C, %e" ),
					new Opcode( 0x31, LD_R16_N16, 10, "LD %R, %N" ),
					new Opcode( 0x32, LDD_mHL_A, 7, "LDD (HL), A" ),
					new Opcode( 0x33, INC16, 6, "INC %R" ),
					new Opcode( 0x34, INC8, 11, "INC (HL)" ),
					new Opcode( 0x35, DEC8, 11, "DEC (HL)" ),
					new Opcode( 0x36, LD_mHL_N8, 10, "LD (HL), %n" ),
					new Opcode( 0x37, SCF, 4, "SCF" ),
					new Opcode( 0x38, JR_CC, 7, "JR %C, %e" ),
					new Opcode( 0x39, ADD_HL_R16, 11, "ADD HL, %R" ),
					new Opcode( 0x3A, LDD_A_mHL, 7, "LDD A, (HL)" ),
					new Opcode( 0x3B, DEC16, 6, "DEC %R" ),
					new Opcode( 0x3C, INC8, 4, "INC %r3" ),
					new Opcode( 0x3D, DEC8, 4, "DEC %r3" ),
					new Opcode( 0x3E, LD_R8_N8, 7, "LD %r3, %n" ), 
					new Opcode( 0x3F, CCF, 4, "CCF" ),
					new Opcode( 0x40, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x41, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x42, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x43, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x44, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x45, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x46, LD_R8_mHL, 7, "LD %r3, (HL)" ),
					new Opcode( 0x47, LD_R8_R8, 4, "LD %r3, %r0" ),					
					new Opcode( 0x48, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x49, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x4A, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x4B, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x4C, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x4D, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x4E, LD_R8_mHL, 7, "LD %r3, (HL)" ),
					new Opcode( 0x4F, LD_R8_R8, 4, "LD %r3, %r0" ),				
					new Opcode( 0x50, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x51, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x52, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x53, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x54, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x55, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x56, LD_R8_mHL, 7, "LD %r3, (HL)" ),
					new Opcode( 0x57, LD_R8_R8, 4, "LD %r3, %r0" ),				
					new Opcode( 0x58, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x59, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x5A, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x5B, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x5C, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x5D, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x5E, LD_R8_mHL, 7, "LD %r3, (HL)" ),
					new Opcode( 0x5F, LD_R8_R8, 4, "LD %r3, %r0" ),			
					new Opcode( 0x60, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x61, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x62, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x63, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x64, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x65, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x66, LD_R8_mHL, 7, "LD %r3, (HL)" ),
					new Opcode( 0x67, LD_R8_R8, 4, "LD %r3, %r0" ),				
					new Opcode( 0x68, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x69, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x6A, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x6B, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x6C, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x6D, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x6E, LD_R8_mHL, 7, "LD %r3, (HL)" ),
					new Opcode( 0x6F, LD_R8_R8, 4, "LD %r3, %r0" ),				
					new Opcode( 0x70, LD_mHL_R8, 7, "LD (HL), %r0" ),
					new Opcode( 0x71, LD_mHL_R8, 7, "LD (HL), %r0" ),
					new Opcode( 0x72, LD_mHL_R8, 7, "LD (HL), %r0" ),
					new Opcode( 0x73, LD_mHL_R8, 7, "LD (HL), %r0" ),
					new Opcode( 0x74, LD_mHL_R8, 7, "LD (HL), %r0" ),
					new Opcode( 0x75, LD_mHL_R8, 7, "LD (HL), %r0" ),
					new Opcode( 0x76, HALT, 4, "HALT" ),
					new Opcode( 0x77, LD_mHL_R8, 7, "LD (HL), %r0" ),				
					new Opcode( 0x78, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x79, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x7A, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x7B, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x7C, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x7D, LD_R8_R8, 4, "LD %r3, %r0" ),
					new Opcode( 0x7E, LD_R8_mHL, 7, "LD %r3, (HL)" ),
					new Opcode( 0x7F, LD_R8_R8, 4, "LD %r3, %r0" ),				
					new Opcode( 0x80, ADD, 4, "ADD %r0" ),
					new Opcode( 0x81, ADD, 4, "ADD %r0" ),
					new Opcode( 0x82, ADD, 4, "ADD %r0" ),
					new Opcode( 0x83, ADD, 4, "ADD %r0" ),
					new Opcode( 0x84, ADD, 4, "ADD %r0" ),
					new Opcode( 0x85, ADD, 4, "ADD %r0" ),
					new Opcode( 0x86, ADD, 7, "ADD (HL)" ),
					new Opcode( 0x87, ADD, 4, "ADD %r0" ),
					new Opcode( 0x88, ADC, 4, "ADC %r0" ),
					new Opcode( 0x89, ADC, 4, "ADC %r0" ),
					new Opcode( 0x8A, ADC, 4, "ADC %r0" ),
					new Opcode( 0x8B, ADC, 4, "ADC %r0" ),
					new Opcode( 0x8C, ADC, 4, "ADC %r0" ),
					new Opcode( 0x8D, ADC, 4, "ADC %r0" ),
					new Opcode( 0x8E, ADC, 7, "ADC (HL)" ),
					new Opcode( 0x8F, ADC, 4, "ADC %r0" ),
					new Opcode( 0x90, SUB, 4, "SUB %r0" ),
					new Opcode( 0x91, SUB, 4, "SUB %r0" ),
					new Opcode( 0x92, SUB, 4, "SUB %r0" ),
					new Opcode( 0x93, SUB, 4, "SUB %r0" ),
					new Opcode( 0x94, SUB, 4, "SUB %r0" ),
					new Opcode( 0x95, SUB, 4, "SUB %r0" ),
					new Opcode( 0x96, SUB, 7, "SUB (HL)" ),
					new Opcode( 0x97, SUB, 4, "SUB %r0" ),					
					new Opcode( 0x98, SBC, 4, "SBC %r0" ),
					new Opcode( 0x99, SBC, 4, "SBC %r0" ),
					new Opcode( 0x9A, SBC, 4, "SBC %r0" ),
					new Opcode( 0x9B, SBC, 4, "SBC %r0" ),
					new Opcode( 0x9C, SBC, 4, "SBC %r0" ),
					new Opcode( 0x9D, SBC, 4, "SBC %r0" ),
					new Opcode( 0x9E, SBC, 7, "SBC (HL)" ),
					new Opcode( 0x9F, SBC, 4, "SBC %r0" ),					
					new Opcode( 0xA0, AND, 4, "AND %r0" ),
					new Opcode( 0xA1, AND, 4, "AND %r0" ),
					new Opcode( 0xA2, AND, 4, "AND %r0" ),
					new Opcode( 0xA3, AND, 4, "AND %r0" ),
					new Opcode( 0xA4, AND, 4, "AND %r0" ),
					new Opcode( 0xA5, AND, 4, "AND %r0" ),
					new Opcode( 0xA6, AND, 7, "AND (HL)" ),
					new Opcode( 0xA7, AND, 4, "AND %r0" ),
					new Opcode( 0xA8, XOR, 4, "XOR %r0" ),
					new Opcode( 0xA9, XOR, 4, "XOR %r0" ),
					new Opcode( 0xAA, XOR, 4, "XOR %r0" ),
					new Opcode( 0xAB, XOR, 4, "XOR %r0" ),
					new Opcode( 0xAC, XOR, 4, "XOR %r0" ),
					new Opcode( 0xAD, XOR, 4, "XOR %r0" ),
					new Opcode( 0xAE, XOR, 7, "XOR (HL)" ),
					new Opcode( 0xAF, XOR, 4, "XOR %r0" ),				
					new Opcode( 0xB0, OR, 4, "OR %r0" ), 
					new Opcode( 0xB1, OR, 4, "OR %r0" ), 
					new Opcode( 0xB2, OR, 4, "OR %r0" ),
					new Opcode( 0xB3, OR, 4, "OR %r0" ),
					new Opcode( 0xB4, OR, 4, "OR %r0" ),
					new Opcode( 0xB5, OR, 4, "OR %r0" ),
					new Opcode( 0xB6, OR, 7, "OR (HL)" ),
					new Opcode( 0xB7, OR, 4, "OR %r0" ), 				
					new Opcode( 0xB8, CP, 4, "CP %r0" ), 
					new Opcode( 0xB9, CP, 4, "CP %r0" ), 
					new Opcode( 0xBA, CP, 4, "CP %r0" ),
					new Opcode( 0xBB, CP, 4, "CP %r0" ),
					new Opcode( 0xBC, CP, 4, "CP %r0" ),
					new Opcode( 0xBD, CP, 4, "CP %r0" ),
					new Opcode( 0xBE, CP, 7, "CP (HL)" ),
					new Opcode( 0xBF, CP, 4, "CP %r0" ),					
					new Opcode( 0xC0, RET_CC, 5, "RET %C" ), 
					new Opcode( 0xC1, POP, 10, "POP %P" ), 
					new Opcode( 0xC2, JP_CC, 10, "JP %C, %N" ), 
					new Opcode( 0xC3, JP, 10, "JP %N" ), 
					new Opcode( 0xC4, CALL_CC, 10, "CALL %C, %N" ), 
					new Opcode( 0xC5, PUSH, 11, "PUSH %P" ), 
					new Opcode( 0xC6, ADD, 7, "ADD %n" ), 
					new Opcode( 0xC7, RST, 11, "RST %t" ),
					new Opcode( 0xC8, RET_CC, 5, "RET %C" ), 
					new Opcode( 0xC9, RET, 10, "RET" ), 
					new Opcode( 0xCA, JP_CC, 10, "JP %C, %N" ), 
					new Opcode( 0xCB, ILLEGAL, 4, "ILLEGAL" ),
					new Opcode( 0xCC, CALL_CC, 10, "CALL %C, %N" ), 
					new Opcode( 0xCD, CALL, 17, "CALL %N" ),
					new Opcode( 0xCE, ADC, 7, "ADC %n" ),
					new Opcode( 0xCF, RST, 11, "RST %t" ),				
					new Opcode( 0xD0, RET_CC, 5, "RET %C" ),
					new Opcode( 0xD1, POP, 10, "POP %P" ), 
					new Opcode( 0xD2, JP_CC, 10, "JP %C, %N" ),
					new Opcode( 0xD3, ILLEGAL, 4, "ILLEGAL" ),
					new Opcode( 0xD4, CALL_CC, 10, "CALL %C, %N" ),
					new Opcode( 0xD5, PUSH, 11, "PUSH %P" ),
					new Opcode( 0xD6, SUB, 7, "SUB %n" ),
					new Opcode( 0xD7, RST, 11, "RST %t" ),
					new Opcode( 0xD8, RET_CC, 5, "RET %C" ),
					new Opcode( 0xD9, RETI, 14, "RETI" ),
					new Opcode( 0xDA, JP_CC, 10, "JP %C, %N" ),
					new Opcode( 0xDB, ILLEGAL, 4, "ILLEGAL" ),
					new Opcode( 0xDC, CALL_CC, 10, "CALL %C, %N" ),
					new Opcode( 0xDD, ILLEGAL, 4, "ILLEGAL" ),
					new Opcode( 0xDE, SBC, 7, "SBC %n" ),
					new Opcode( 0xDF, RST, 11, "RST %t" ),
					new Opcode( 0xE0, LD_mFFN8_A, 10, "LD (FF00h+%n), A" ),
					new Opcode( 0xE1, POP, 10, "POP %P" ),
					new Opcode( 0xE2, LD_mFFC_A, 7, "LD (FF00h+C), A" ),
					new Opcode( 0xE3, ILLEGAL, 4, "ILLEGAL" ),
					new Opcode( 0xE4, ILLEGAL, 4, "ILLEGAL" ),
					new Opcode( 0xE5, PUSH, 11, "PUSH %P" ),
					new Opcode( 0xE6, AND, 7, "AND %n" ),
					new Opcode( 0xE7, RST, 11, "RST %t" ),				
					new Opcode( 0xE8, ADD_SP_N8, 11, "ADD SP, %o" ),
					new Opcode( 0xE9, LD_PC_HL, 6, "LD PC, HL" ),
					new Opcode( 0xEA, LD_mN16_A, 13, "LD (%N), A" ),
					new Opcode( 0xEB, ILLEGAL, 4, "ILLEGAL" ),
					new Opcode( 0xEC, ILLEGAL, 4, "ILLEGAL" ),
					new Opcode( 0xED, ILLEGAL, 4, "ILLEGAL" ),
					new Opcode( 0xEE, XOR, 7, "XOR %n" ),
					new Opcode( 0xEF, RST, 11, "RST %t" ),			
					new Opcode( 0xF0, LD_A_mFFN8, 10, "LD A, (FF00h+%n)" ),
					new Opcode( 0xF1, POP, 10, "POP %P" ),
					new Opcode( 0xF2, LD_A_mFFC, 7, "LD A, (FF00h+C)" ),
					new Opcode( 0xF3, DI, 4, "DI" ),
					new Opcode( 0xF4, ILLEGAL, 4, "ILLEGAL" ),
					new Opcode( 0xF5, PUSH, 11, "PUSH %P" ),
					new Opcode( 0xF6, OR, 7, "OR %n" ),
					new Opcode( 0xF7, RST, 11, "RST %t" ),				
					new Opcode( 0xF8, LD_HL_SPN8, 15, "LD HL, SP+%o" ), 
					new Opcode( 0xF9, LD_SP_HL, 6, "LD SP, HL" ),
					new Opcode( 0xFA, LD_A_mN16, 13, "LD A, (%N)" ),
					new Opcode( 0xFB, EI, 4, "EI" ),
					new Opcode( 0xFC, ILLEGAL, 4, "ILLEGAL" ),
					new Opcode( 0xFD, ILLEGAL, 4, "ILLEGAL" ),
					new Opcode( 0xFE, CP, 7, "CP %n" ),
					new Opcode( 0xFF, RST, 11, "RST %t" ),
				};
				
			}
			
		}
		
	}
	
}
	
