﻿using System;
using GameKnight.Core;

namespace GameKnight
{
	
	namespace GameBoy
	{

		public partial class Register : IRegister
		{
			
			public class BNK : IRegister
			{

            	private readonly byte[] DataArray = new byte[2] { 1, 0 };

				public int VideoBank
            	{
            		get
            		{
            			return DataArray[1];
            		}
            	}

            	public int WorkBank
            	{
            		get
            		{
            			return DataArray[0];
            		}
            	}

				public BNK()
				{
					return;
				}
				
				public byte this[int Address]
				{
					get
					{
						return DataArray[Address&0x01];
					}
					set
					{
						switch( Address & 0x01 )
						{
							case 0:
                            	DataArray[0] = (byte)( ( ( value & 0x07 ) == 0 ) ? 1 : ( value & 0x07 ) );
                            	break;
                            case 1:
                            	DataArray[1] = (byte)( value & 0x01 );
                            	break;
                            default:
                            	break;
						}
					}
				}

			}
			
		}
		
	}
	
}






