using System;
using GameKnight.Core;

namespace GameKnight
{
	
	namespace GameBoy
	{

		public partial class VideoMemory : IVideoMemory
		{
		
			private class AttributeTable : Bank, IAttributeTable
			{
	
				public int Address
				{
					get
					{
						return AddressProperty;
					}
					private set
					{
	                	AddressProperty = value;
					}
				}
	
				private int AddressProperty = 0;
					
				public ISize Size
				{
					get
					{
						return SizeProperty;
					}
				}
	
				private static readonly Size SizeProperty = new Size( 32, 32 );

				private static readonly TileAttributes[] TileAttributesArray = new TileAttributes[256];

				private readonly IVideoMemory VideoMemory = null;
	
				public AttributeTable( IVideoMemory VideoMemory, int Address ) : base( 0x400 )
				{
					this.VideoMemory = VideoMemory;
					this.Address = Address;
					for( int i = 0; i < TileAttributesArray.Length; i++ )
					{
						TileAttributesArray[i] = new TileAttributes( (byte)i );
					}
					return;
				}
				
				public ITileAttributes GetTileAttributes( int Index )
				{
					return TileAttributesArray[this[Index&0x3FF]];
				}
				
			}
				
		}
		
	}
	
}
