using System;
using GameKnight.Core;

namespace GameKnight
{
	
	namespace GameBoy
	{

		public partial class VideoMemory : IVideoMemory
		{
		
			private class NameTable : Bank, INameTable
			{
	
				public int Address
				{
					get
					{
						return AddressProperty;
					}
					private set
					{
	                	AddressProperty = value;
					}
				}
	
				private int AddressProperty = 0;
	
				public ISize Size
				{
					get
					{
						return SizeProperty;
					}
				}
	
				private static readonly Size SizeProperty = new Size( 32, 32 );
	
				private readonly IVideoMemory VideoMemory = null;
	
				public NameTable( IVideoMemory VideoMemory, int Address ) : base( 0x400 )
				{
					this.VideoMemory = VideoMemory;
					this.Address = Address;
					return;
				}
				
				public int GetTileIndex( int Index )
				{
					return this[Index&0x3FF];
				}
				
			}
				
		}
		
	}
	
}
