using System;
using GameKnight.Core;

namespace GameKnight
{
	
	namespace GameBoy
	{
		
		public partial class VideoMemory : IVideoMemory
		{
		
			private class PatternTable : Bank, IPatternTable
			{
	
				public int Address
				{
					get
					{
						return AddressProperty;
					}
					private set
					{
	                	AddressProperty = value;
					}
				}
	
				private int AddressProperty = 0;
	
				private readonly int Mask = 0;
				
				public int Tiles
				{
					get
					{
						return 256;
					}
				}
	
				private readonly ITile[] TileArray = new ITile[256];
	
			//	private readonly IVideoMemory VideoMemory = null;
	
				public PatternTable( IVideoMemory VideoMemory, int Address ) : base( 0x1000 )
				{
				//	this.VideoMemory = VideoMemory;
					this.Address = Address;
					if( ( Address & 0x8800 ) == 0x8800 )
					{
						this.Mask = 0x80;
					}
					for( int i = 0; i < TileArray.Length; i++ )
					{
						this.TileArray[i] = new Tile( VideoMemory, this, ( Address + ( i * 16 ) ) );
					}
					return;
				}
				
				public ITile GetTile( int Index )
				{
					return TileArray[(Index^Mask)%Tiles];
				}
				
			}
				
		}
		
	}

}
