using System;
using Drawing = System.Drawing;
using Forms = System.Windows.Forms;
using GameKnight.Core;

namespace GameKnight.Win32
{

//	public partial class Application : IInterface
//	{
		
//		private partial class ControllerDialog : Forms.Form
//		{

			public sealed class ControlPanel : Forms.Panel
			{
				
				private readonly IControl Control = null;
			
				private readonly InputDevice InputDevice = null;
			
				public Forms.Keys Key
				{
					get
					{
						return KeyProperty;
					}
					private set
					{
						KeyProperty = value;
						if( KeyChanged != null )
						{
							KeyChanged( this, EventArgs.Empty );
						}
					}
				}
				
				private event EventHandler KeyChanged = null;
				
				private Forms.Keys KeyProperty = Forms.Keys.None;
					
				private readonly Forms.Label Label = new Forms.Label();
									
				private readonly Forms.TextBox TextBox = new Forms.TextBox();
							
				public ControlPanel( InputDevice InputDevice, IControl Control ) : base()
				{
					this.InputDevice = InputDevice;
					this.Control = Control;
					this.KeyChanged += KeyChangedEvent;
					this.Key = InputDevice[Control];
					this.Size = new Drawing.Size( 160, 32 );
					this.Label.Text = Control.Name + ":";
					this.Label.Bounds = new Drawing.Rectangle( 4, 8, 54, 24 );
					this.Controls.Add( Label );
					this.TextBox.ReadOnly = true;
					this.TextBox.TextAlign = Forms.HorizontalAlignment.Center;
					this.TextBox.Bounds = new Drawing.Rectangle( 62, 4, 94, 24 );
					this.TextBox.BackColor = Drawing.SystemColors.Window;
					this.TextBox.ForeColor = Drawing.SystemColors.WindowText;
					this.TextBox.Enter += TextBoxEnterEvent;
					this.TextBox.Leave += TextBoxLeaveEvent;
					this.TextBox.KeyDown += TextBoxKeyDownEvent;
					this.Controls.Add( TextBox );
					return;
				}
				
				private void KeyChangedEvent( object Sender, EventArgs Arguments )
				{
					TextBox.Text = Key.ToString();
					InputDevice[Control] = Key;
					return;
				}
				
				private void TextBoxEnterEvent( object Sender, EventArgs Arguments )
				{
					TextBox.BackColor = Drawing.SystemColors.Highlight;
					TextBox.ForeColor = Drawing.SystemColors.HighlightText;
					return;
				}
				
				private void TextBoxKeyDownEvent( object Sender, Forms.KeyEventArgs Arguments )
				{
					Key = Arguments.KeyCode;
					return;
				}
				
				private void TextBoxLeaveEvent( object Sender, EventArgs Arguments )
				{
					TextBox.BackColor = Drawing.SystemColors.Window;
					TextBox.ForeColor = Drawing.SystemColors.WindowText;
					return;
				}
		
			}
			
		}
		
//	}
	
//}
