﻿using System;
using System.Runtime.InteropServices;

using Direct3D = SlimDX.Direct3D;
using Direct3D9 = SlimDX.Direct3D9;

namespace GameKnight.Win32
{
	
	[StructLayout(LayoutKind.Sequential)]
	public struct CustomVertex
	{
				
		public SlimDX.Vector3 Position;
		
		public SlimDX.Vector2 TextureCoordinates;
		
		public static int SizeBytes
		{
			get 
			{
				return Marshal.SizeOf( typeof( CustomVertex ) );
			}
		}
		
		public static Direct3D9.VertexFormat Format
		{
			get
			{
				return Direct3D9.VertexFormat.Position | Direct3D9.VertexFormat.Texture1;
			}
		}
		
		public CustomVertex( float X, float Y, float Tu, float Tv )
		{
			Position = new SlimDX.Vector3( X, Y, 0.5f );
			TextureCoordinates = new SlimDX.Vector2( Tu, Tv );
			return;
		}
		
	}

}


